#include "z80_def.h"


int SPNM(halfframe)(int firsttick, int numlines)
{
  int tc, linesleft;
  int feport, scri, coli, scline;
  qbyte *scrptr;
  qbyte brd_color;
  int i;
  qbyte *tmptr, *mptr;
  qbyte mark, cmark = 0;

  scrptr = (qbyte *) SPNM(image);

  tc = firsttick - CHKTICK;

  for(linesleft = numlines; linesleft; linesleft--) {
    DANM(next_scri) = SPNM(scri)[SPNM(scline)];

    tc += CHKTICK;
    tc = PRNM(step)(tc);

    scline = SPNM(scline);

    /* store sound */
    SPNM(sound_buf)[scline] = DANM(sound_sam);
    feport = DANM(ula_outport);
    
    if(feport & SOUNDPORT) DANM(sound_sam) = 240;
    else DANM(sound_sam) = 16;

    /* change EAR bit, store MIC bit*/

    SPNM(fe_outport_time)[scline] = feport;
    DANM(ula_inport) = SPNM(fe_inport_time)[scline];

    /* Check if updating screen */

    if(SPNM(updating)) {
      if((feport & 0x07) != SPNM(lastborder)) {
	SPNM(border_update) = 2;
	SPNM(lastborder) = feport & 0x07;
      }
      scri = DANM(next_scri);
      if(scri >= 0) {          /* normal line */
	if(SPNM(border_update)) {
	  brd_color = SPNM(colors)[feport & 0x07];
	  brd_color |= brd_color << 8;
	  brd_color |= brd_color << 16;

	  for(i = 8; i; i--) *scrptr++ = brd_color;
	  scrptr += 0x40;
	  for(i = 8; i; i--) *scrptr++ = brd_color;
	  scrptr -= 0x48;
	}
	else scrptr += 0x08;

	coli = SPNM(coli)[scline];

	tmptr = SPNM(scr_mark) + 0x2C0 + (coli >> 3);
	mark = *tmptr;
	if(!(coli & 0x07)) {
	  cmark = mark;
	  *tmptr = 0;
	}
	else cmark |= mark;

	mptr = SPNM(scr_mark) + scri;

	mark = *mptr | cmark;
	if(mark) {
	  byte *spmp, *spcp;
	  qbyte *scr_tab;

	  *mptr = 0;
	  SPNM(imag_mark)[coli] |= mark;
	  SPNM(imag_horiz) |= mark;
	  coli >>= 3;
	  SPNM(imag_vert) |= (1 << coli);
	  
	  spmp = PRNM(proc).mem + (scri << 5);
	  spcp = PRNM(proc).mem + 0x5800 + (coli << 5);

	  if(!SPNM(flash_state)) scr_tab = SPNM(scr_f0_table);
	  else scr_tab = SPNM(scr_f1_table);

	  for(i = 32; i; i--) {
	    register dbyte spcx, spmx;
	    spcx = (*spcp++) << 6;
	    spmx = *spmp++;
	    *scrptr++ = scr_tab[spcx|((spmx & 0xf0) >> 4)];
	    *scrptr++ = scr_tab[spcx|((spmx & 0x0f))];
	  }
	  scrptr +=0x08;
	}
	else scrptr += 0x48;
      }
      else if(scri == -1) {  /* only border */
	if(SPNM(border_update)) {
	  brd_color = SPNM(colors)[feport & 0x07];
	  brd_color |= brd_color << 8;
	  brd_color |= brd_color << 16;

	  for(i = 0x50; i; i--) *scrptr++ = brd_color;
	}
	else scrptr += 0x50;
      }
    }
    SPNM(scline)++;
  }
  return tc;
}
