/* 
 * Copyright (C) 1996 Szeredi Miklos
 * Email: mszeredi@eik.bme.hu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version. See the file COPYING. 
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "spperif.h"
#include "z80.h"

#include "spscr.h"
#include "spkey.h"
#include "spmain.h"
#include "sptape.h"
#include "spsound.h"
#include "xscr.h"

#include "ax.h"

#include <stdio.h>

#define DIR_SEP_CHAR '/'

static char *get_base_name(char *fname)
{
  char *p = fname;
  for(; *p; p++);
  for(; p >= fname && *p != DIR_SEP_CHAR; p--);
  return ++p;
}

int main(int argc, char *argv[])
{
  aX_default_resources defres;

  sp_init();

  
  defres.width = 0;
  defres.height = 0;
  defres.x = 0;
  defres.y = 0;
  defres.border_width = 10;
  defres.foreground = 0;
  defres.background = 1;
  defres.font_name = "7x14";
  defres.fallback_font_name = NULL;
  defres.prog_name = get_base_name(argv[0]);
  defres.class_name = "XSpscreen";

  aX_open_disp(NULL, 0, &argc, argv, &defres);

  init_x_scr(&defres, &argc, argv);
  
  init_spect_scr();
  init_spect_sound();
  init_spect_key();

  print_copyright();
  initial_load_file(argc, argv);
  run_singlemode();

  return 0;
}
