
#define ADDSUB(r, op, tbl) \
{                                  \
  register byte res;               \
  register int idx;                \
  register int flag;               \
  res = RA op;                     \
  idx = IDXCALC(RA, r, res);       \
  RA = res;                        \
  flag = (RF & ~(ALLF)) |          \
         TAB(tbl)[idx];            \
  if(!res) flag |= ZF;             \
  RF = flag;			   \
}  


#define ADD(r) ADDSUB(r, + r, addf_tbl)
#define ADC(r) ADDSUB(r, + r + (RF & CF), addf_tbl) 
#define SUB(r) ADDSUB(r, - r, subf_tbl)
#define SBC(r) ADDSUB(r, - r - (RF & CF), subf_tbl)

#define AND(r) \
{                                  \
  register byte res;               \
  register byte flag;              \
  res = RA & r;                    \
  RA = res;                        \
  flag = (RF & ~(ALLF)) |          \
         TAB(orf_tbl)[res] | HF;   \
  RF = flag;                       \
}


#define XOR(r) \
{                                  \
  register byte res;               \
  register byte flag;              \
  res = RA ^ r;                    \
  RA = res;                        \
  flag = (RF & ~(ALLF)) |          \
         TAB(orf_tbl)[res];        \
  RF = flag;                       \
}


#define OR(r) \
{                                  \
  register byte res;               \
  register byte flag;              \
  res = RA | r;                    \
  RA = res;                        \
  flag = (RF & ~(ALLF)) |          \
         TAB(orf_tbl)[res];        \
  RF = flag;                       \
}


#define CP(r) \
{                                  \
  register byte res;               \
  register int idx;                \
  register int flag;               \
  res = RA - r;                    \
  idx = IDXCALC(RA, r, res);       \
  flag = (RF & ~(ALLF)) |          \
         TAB(subf_tbl)[idx];       \
  if(!res) flag |= ZF;             \
  RF = flag;			   \
}  
